' Swe Gothenburg Pollen v1.0	2004-05-07	by: wesaft
'
' grabs the pollen data from www.miljo.goteborg.se
' thanks Nem for the template :)
'
'------------------------------------------------------------------------
' Internet Script Template (v1.1)
'------------------------------------------------------------------------
'
' *** SCRIPT REQUEST ***
'
' A customisable template that should allow you to effectively write your
' own scripts with very little (or no) VBscripting knowledge. All you
' have to do is examine the HTML source for the page you want to get
' data from and change the six variables below.
'
' The script is already set up to work with FilePlanet.com, so if you
' want to have a good idea as to how this script works, I advise that
' you examine the source of the fileplanet.com website as well.
'
' PLEASE NOTE: I will provide very little (if any) support for this
' ------------ script. I only made it because I was asked by a user of my
'              portal for a Script Template so he could have a go at
'              making his own scripts.
'
'              There are quite a few things that could go wrong with it
'              (as far as wetting the variables below is concerned) so 
'              only attempt to use it if you have *SOME* idea of what
'              you are doing ;)
'              
'
' 					                       - NeM 

'=========================================================================
' VARIABLES TO CHANGE:
'=========================================================================

'=========================================================================
' The name of the temp file you want to use for the script (needed for
' the GetInfoTempFile() function only)
'=========================================================================
TMP_FILE = "pollen.tmp"
'=========================================================================



'=========================================================================
' The url of the site you want to get your data from
'=========================================================================
SITE_URL = "http://www.miljo.goteborg.se/luftnet/pollen/index.htm"
'=========================================================================



'=========================================================================
' A string in the HTML source to verify that you have got the right page
' (eg. use the page title)
'=========================================================================
PAGE_CHECK = "</span>Uppmtta vrden luftburet"
'=========================================================================



'=========================================================================
' String to search for first - to advance to a spot just before each 
' data item you want to extract. 
' (NOTE: text containing quote marks (") must have two " marks to signify
' a " in the text.)
'=========================================================================
FIRST_CHECK = "Pollen.xls]Blankett 1"
'=========================================================================



'=========================================================================
' String marking the end of all text before the text you are interested in
' (eg. if you were interested in the text of a hyperlink:
'
'         <a href="somesite">My Text</a> 
'
' you would set this to  "somesite"">" for example.
'=========================================================================
FIRST_CHECK2 = ")"">"
'=========================================================================


'=========================================================================
' String marking the end of the text you are interested in. eg. if you
' were interested in the text of a hyperlink:
'
'         <a href="somesite">My Text</a>
'
' you would set this to "</a>"
'=========================================================================
END_CHECK = "<"
'=========================================================================


'=========================================================================
' Set to True if you want new line characters removed from the output.
'
' eg. this:
'
'           Item 1
'           Item 2
'           Item 3
'
' would become this:
'
'           Item 1 Item 2 Item 3
'
'=========================================================================
REMOVE_NEWLINES = True
'=========================================================================


'=========================================================================
' DO NOT MODIFY ANYTHING PAST HERE UNLES YOU KNOW WHAT YOU ARE DOING!
'=========================================================================
dim pollen(10)
GetInfo

Function GetAl()
	GetAl = pollen(0)
End Function

Function GetAlInt()
	GetAlInt = getInt(pollen(0))
End Function

Function GetAlm()
	GetAlm = pollen(1)
End Function

Function GetAlmInt()
	GetAlmInt = getInt(pollen(1))
End Function

Function GetBjork()
	GetBjork = pollen(2)
End Function

Function GetBjorkInt()
	GetBjorkInt = getInt(pollen(2))
End Function

Function GetBok()
	GetBok = pollen(3)
End Function

Function GetBokInt()
	GetBokInt = getInt(pollen(3))
End Function

Function GetEk()
	GetEk = pollen(4)
End Function

Function GetEkInt()
	GetEkInt = getInt(pollen(4))
End Function

Function GetHassel()
	GetHassel = pollen(5)
End Function

Function GetHasselInt()
	GetHasselInt = getInt(pollen(5))
End Function

Function GetViden()
	GetViden = pollen(6)
End Function

Function GetVidenInt()
	GetVidenInt = getInt(pollen(6))
End Function

Function GetGrabo()
	GetGrabo = pollen(7)
End Function

Function GetGraboInt()
	GetGraboInt = getInt(pollen(7))
End Function

Function GetGras()
	GetGras = pollen(8)
End Function

Function GetGrasInt()
	GetGrasInt = getInt(pollen(8))
End Function

private Function getInt(p)
	p = Left(p,2)
	if p = "-" then
		getInt = 0
	end if
	if p = "L" then
		getInt = 1
	end if
	if p = "M" then
		getInt = 2
	end if
	if p = "H" then
		getInt = 3
	end if
	if p = "My" then
		getInt = 4
	end if
End Function

private Function GetInfo()		

	dim htmlResult,output,newsItem,mainFeature
	int i
	htmlResult = ReturnHTML(SITE_URL)
	output = NULL
	i = 0

	startPos = instr(htmlResult, PAGE_CHECK)

	if startPos > 0 then

		Do While instr(startPos, htmlResult, FIRST_CHECK)>0

			posOne = instr( startPos, htmlResult, FIRST_CHECK)
			posOne = instr( posOne, htmlResult, FIRST_CHECK2) + Len(FIRST_CHECK2)	

			posTwo = instr( posOne, htmlResult, END_CHECK)

			if posOne > 0 AND posTwo > posOne Then

				'grab the name of the news item
				newsItem = right(mid( htmlResult, posOne, posTwo-posOne ), posTwo-posOne)
				newsItem = trim(replace(newsitem, vbcrlf,""))
			end if

			' new start position
			startPos = posTwo

			'append the user to the list and put a newline char after it
			output = output & newsItem

			pollen(i) = newsItem
			i = i + 1

			' don't add a newline to the last item
			If instr(startPos, htmlResult, FIRST_CHECK)>0 Then
				output = output & (Chr(13) & Chr(10))
			End If



		Loop

	else
		output = "Could not obtain data."
	end if

	GetInfo = TrimHTML(output)
	GetInfo = ReplaceHTML(GetInfo)

	If REMOVE_NEWLINES then
		GetInfo = Replace(GetInfo, vbCr, " ")
		GetInfo = Replace(GetInfo, vbLf, " ")
		GetInfo = Replace(GetInfo, vbCrLf, " ")
	End If
	
	GetInfo = Trim(GetInfo)

End Function

private Function GetInfoTempFile()

	set fs=CreateObject("Scripting.FileSystemObject")
	set f=fs.CreateTextFile(TMP_FILE,true)
	f.write(GetInfo())
	f.close
	set f=nothing
	set fs=nothing

	GetInfoTempFile = "OK!"

End Function

Private Function ReturnHTML(sURL)
	Dim objXMLHTTP,HTML
	Set objXMLHTTP = CreateObject("Microsoft.XMLHTTP")
	objXMLHTTP.Open "GET", sURL, False
	objXMLHTTP.Send
	HTML = objXMLHTTP.responseBody
	Set objRS = CreateObject("ADODB.Recordset")
	objRS.Fields.Append "txt", 200, 45000, &H00000080
	objRS.Open
	objRS.AddNew
	objRS.Fields("txt").AppendChunk HTML
	ReturnHTML = objRS("txt").Value
	objRS.Close
	Set objRS = Nothing
	Set objXMLHTTP = Nothing
End Function


'very simple function that will remove all html tags
'(posted by Alderaic)
'---------------------------------------------------
Private Function TrimHTML(str)
pos_deb = InStr(1, str, "<")
Do Until pos_deb = 0
    pos_fin = InStr(pos_deb, str, ">")
    part_d = Mid(str, 1, pos_deb - 1)
    part_f = Mid(str, pos_fin + 1, Len(str) - pos_fin)
    str = part_d & part_f
    pos_deb = InStr(1, str, "<")
Loop
TrimHTML = str
End Function


'ReplaceHTML (posted by Goodspeed)
'---------------------------------
Private Function ReplaceHTML(str)

 str = replace(str, "&auml;", "")
 str = replace(str, "&uuml;", "")
 str = replace(str, "&ouml;", "")
 str = replace(str, "&Auml;", "")
 str = replace(str, "&Uuml;", "")
 str = replace(str, "&Ouml;", "")
 str = replace(str, "&szlig;", "")
 str = replace(str, "&quot;", """")
 str = replace(str, "&euro;", "")
 str = replace(str, "&pound;", "")
 str = replace(str, "&yen;", "")
 str = replace(str, "&amp;", "&")
 str = replace(str, "&lt;", "<")
 str = replace(str, "&gt;", ">")
 str = replace(str, "&iexcl;", "")
 str = replace(str, "&cent;", "")
 str = replace(str, "&curren;", "")
 str = replace(str, "&brvbar;", "")
 str = replace(str, "&sect;", "")
 str = replace(str, "&uml;", "")
 str = replace(str, "&copy;", "")
 str = replace(str, "&ordf;", "")
 str = replace(str, "&laquo;", "")
 str = replace(str, "&not;", "")
 str = replace(str, "&shy;", "")
 str = replace(str, "&reg;", "")
 str = replace(str, "&macr;", "")
 str = replace(str, "&deg;", "")
 str = replace(str, "&plusmn;", "")
 str = replace(str, "&sup2;", "")
 str = replace(str, "&sup3;", "")
 str = replace(str, "&acute;", "")
 str = replace(str, "&micro;", "")
 str = replace(str, "&para;", "")
 str = replace(str, "&middot;", "")
 str = replace(str, "&cedil;", "")
 str = replace(str, "&sup1;", "")
 str = replace(str, "&ordm;", "")
 str = replace(str, "&raquo;", "")
 str = replace(str, "&frac14;", "")
 str = replace(str, "&frac12;", "")
 str = replace(str, "&frac34;", "")
 str = replace(str, "&iquest;", "")
 str = replace(str, "&Agrave;", "")
 str = replace(str, "&Aacute;", "")
 str = replace(str, "&Acirc;", "")
 str = replace(str, "&Atilde;", "")
 str = replace(str, "&Aring;", "")
 str = replace(str, "&AElig;", "")
 str = replace(str, "&Ccedil;", "")
 str = replace(str, "&Egrave;", "")
 str = replace(str, "&Eacute;", "")
 str = replace(str, "&Ecirc;", "")
 str = replace(str, "&Euml;", "")
 str = replace(str, "&Igrave;", "")
 str = replace(str, "&Iacute;", "")
 str = replace(str, "&Icirc;", "")
 str = replace(str, "&Iuml;", "")
 str = replace(str, "&ETH;", "")
 str = replace(str, "&Ntilde;", "")
 str = replace(str, "&Ograve;", "")
 str = replace(str, "&Oacute;", "")
 str = replace(str, "&Ocirc;", "")
 str = replace(str, "&Otilde;", "")
 str = replace(str, "&times;", "")
 str = replace(str, "&Oslash;", "")
 str = replace(str, "&Ugrave;", "")
 str = replace(str, "&Uacute;", "")
 str = replace(str, "&Ucirc;", "")
 str = replace(str, "&Yacute;", "")
 str = replace(str, "&THORN;", "")
 str = replace(str, "&agrave;", "")
 str = replace(str, "&aacute;", "")
 str = replace(str, "&acirc;", "")
 str = replace(str, "&atilde;", "")
 str = replace(str, "&aring;", "")
 str = replace(str, "&aelig;", "")
 str = replace(str, "&ccedil;", "")
 str = replace(str, "&egrave;", "")
 str = replace(str, "&eacute;", "")
 str = replace(str, "&ecirc;", "")
 str = replace(str, "&euml;", "")
 str = replace(str, "&igrave;", "")
 str = replace(str, "&iacute;", "")
 str = replace(str, "&icirc;", "")
 str = replace(str, "&iuml;", "")
 str = replace(str, "&eth;", "")
 str = replace(str, "&ntilde;", "")
 str = replace(str, "&ograve;", "")
 str = replace(str, "&oacute;", "")
 str = replace(str, "&ocirc;", "")
 str = replace(str, "&divide;", "")
 str = replace(str, "&oslash;", "")
 str = replace(str, "&ugrave;", "")
 str = replace(str, "&uacute;", "")
 str = replace(str, "&ucirc;", "")
 str = replace(str, "&yacute;", "")
 str = replace(str, "&thorn;", "")
 str = replace(str, "&yuml;", "")
 
 ReplaceHTML = Str
 
End Function